if(!global.__stack) {

	Object.defineProperty(global, '__stack', {
		get: function() {
			var orig = Error.prepareStackTrace;
			Error.prepareStackTrace = function(_, stack) {
				return stack;
			};
			var err = new Error;
			Error.captureStackTrace(err, arguments.callee);
			var stack = err.stack;
			Error.prepareStackTrace = orig;
			return stack;
		}
	});

}

if(!global.__line) {
	Object.defineProperty(global, '__line', {
		get: function() {
			return __stack[1].getLineNumber();
		}
	});
}

if(!global.__function) {
	Object.defineProperty(global, '__function', {
		get: function() {
			return __stack[1].getFunctionName();
		}
	});
}